////////////////////////////////////GPS HAMRADIO CLOCK V1.0 , 27/10/2017  by LB8IG  based on skethc by ON7EQ////////////////
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27, 16, 4);
#include "math.h" 
#include <SoftwareSerial.h>
const byte rxPin = 4;
const byte txPin = 3;
SoftwareSerial mySerial (rxPin, txPin);

// LCD specific characters 'degrees' and 'minutes'

byte degree [8] = {
  B00100,
  B01010,
  B00100,
  B00000,
  B00000,
  B00000,
  B00000,
};

byte decminute [8] = {
  B00100,
  B00100,
  B01000,
  B00000,
  B00000,
  B00000,
  B00100,
};

// Set the GPSRATE to the baud rate of the GPS module.
#define GPSRATE 9600

// The buffer size that will hold a GPS sentence. 
#define BUFFSIZ 90 

// global variables
char buffer[BUFFSIZ];        // string buffer for the sentence
char *parseptr;              // a character pointer for parsing
char buffidx;                // an indexer into the buffer

//unsigned long StartTime = 0; // timing reference
unsigned long ParseTime = 0; // timing reference

// The time, date, location data, etc.
uint8_t hour, minute, second, year, month, date;
unsigned long latitude, longitude;
unsigned groundspeed, trackangle;
char latdir, longdir;
char fixstatus;
byte oldfixstatus = 0;  // previous fix status
unsigned long DisplayTime = 0;    // timer display refresh

char* FirstCharString[]={"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R"};
char* MidCharString[]={"0","1","2","3","4","5","6","7","8","9"};
char* LastCharString[]={"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X"};

float scrap;  // variable for calculations
float loclat;  // variable for LOC calculations
float loclong;  // variable for LOC calculations

////////////////////    S E T U P ///////////////////////

void setup() 
{ 
 
  // set up the LCD's number of columns and rows: 
  lcd.begin();
  ; // wait to allow LCD display to init
 
   // Use the pin 13 LED as an indicator
  pinMode(13, OUTPUT);
    
     // connect to the GPS at the desired rate
  mySerial.begin(GPSRATE);
   
  // Print a message to the LCD.
  lcd.setCursor(1, 0);
  lcd.print("UTC GPS CLOCK");
  lcd.setCursor(0, 1);
  lcd.print("*****LB8IG*****");
  lcd.setCursor(-2, 3);
  lcd.print("Ver.1.0 2017");

  delay (10000);
 // create special characters  
  lcd.createChar(0, degree);
  lcd.createChar(1, decminute);

 PrintTemplate();
 
 } 
/////////////////  L O O P //////////////////////

void loop() { 
  
  uint32_t tmp;
  
  readline();
      
  // check if $GPRMC (global positioning fixed data)

  if (strncmp(buffer, "$GPRMC",6) == 0) {
  
     digitalWrite(13, HIGH); /// DEBUG - valid string detected 
     delay (10); 
     digitalWrite(13, LOW);  
    
    // grab hhmmss time data
    parseptr = buffer+7;
    tmp = parsedecimal(parseptr); 
    hour = tmp / 10000;
    minute = (tmp / 100) % 100;
    second = tmp % 100;
    
    // grab status
    parseptr = strchr(parseptr, ',') + 1;
    fixstatus = parseptr[0];
    parseptr += 2;
    
    // grab latitude data
    latitude = parsedecimal(parseptr);
    if (latitude != 0) {
    //latitude *= 10000;  // if NMEA 4 digits precision after decimal point
    latitude *= 100000; //if NMEA 5 digits precision after decimal point
  
      parseptr = strchr(parseptr, '.')+1;
      latitude += parsedecimal(parseptr);
    }
    parseptr = strchr(parseptr, ',') + 1;
    
    // grab latitude N/S data
    if (parseptr[0] != ',') {
      latdir = parseptr[0];
    }
           
    // grab longitude data
    parseptr = strchr(parseptr, ',')+1;
    longitude = parsedecimal(parseptr);
    if (longitude != 0) {
    //  longitude *= 10000;  // if NMEA 4 digits precision after decimal point
    longitude *= 100000; //if NMEA 5 digits precision after decimal point
      parseptr = strchr(parseptr, '.')+1;
      longitude += parsedecimal(parseptr);
    }
    parseptr = strchr(parseptr, ',')+1;
    
    // grab longitude E/W data
    if (parseptr[0] != ',') {
      longdir = parseptr[0];
    }
    
    // grab groundspeed
    parseptr = strchr(parseptr, ',')+1;
    groundspeed = parsedecimal(parseptr);
    groundspeed = groundspeed * 185; //kts to km/h
    groundspeed = groundspeed / 100; //kts to km/h  
    
    // grab track angle
    parseptr = strchr(parseptr, ',')+1;
    trackangle = parsedecimal(parseptr);

    // grab date
    parseptr = strchr(parseptr, ',')+1;
    tmp = parsedecimal(parseptr); 
    date = tmp / 10000;
    month = (tmp / 100) % 100;
    year = tmp % 100;
    
// update LCD

    latitude = latitude/10;   //if GPS NMEA 5 digits precision after DP
    longitude= longitude/10;  //if GPS NMEA 5 digits precision after DP

   LCDprint();

  } // end $GPRMC NMEASTRING detected
   
}  ///////////// E N D    L O O P //////////////////

uint32_t parsedecimal(char *str) {
  uint32_t d = 0;
  
  while (str[0] != 0) {
   if ((str[0] > '9') || (str[0] < '0'))
     return d;
   d *= 10;
   d += str[0] - '0';
   str++;
  }
  return d;
}

////////   SERIAL INPUT READ ///////////

void readline(void) {

  char c;
  
  buffidx = 0; // start at beginning
  while (1) {
      if (millis() - ParseTime > 3000) NoGPS(); 
      c=mySerial.read();
      if (c == -1)
      continue;
       if (c == '\n')
        continue;
      if ((buffidx == BUFFSIZ-1) || (c == '\r')) {
        buffer[buffidx] = 0;
        return;
      }
      ParseTime = millis();
      buffer[buffidx++]= c;
  }
}

////////////////   GPS ERROR ////////////////////

void NoGPS () {

 //Print template ERROR MSG, no serial data detected
  lcd.clear(); 
  lcd.setCursor(0, 0); 
  lcd.print("NO GPS INPUT"); 
  lcd.setCursor(0, 1);  
  lcd.print("     WAIT.....");  
  digitalWrite(3, HIGH);  /// BEEP    
  delay(50); 
  digitalWrite(3, LOW);    
  delay(1500);
  ParseTime = millis();
  
PrintTemplate();
loop();
}

////////////////   PRINT TEMPLATE ////////////////////

void PrintTemplate () {

  lcd.clear(); 
  lcd.setCursor(-4, 2); 
  lcd.print("LAT"); 
  lcd.setCursor(1, 2);  
  lcd.print("--");   
  lcd.write(0);  
  lcd.print("--");   
  lcd.write(1);  
  lcd.print("--");

  lcd.setCursor(-4, 3); 
  lcd.print("LON"); 
  lcd.setCursor(0, 3);  
  lcd.print("---");   
  lcd.write(0);  
  lcd.print("--");   
  lcd.write(1);  
  lcd.print("--");

  lcd.setCursor(0, 1); 
  lcd.print("QTH  "); 
  lcd.setCursor(5, 1);  
  lcd.print("------");   

  lcd.setCursor(11, 0); 
  lcd.print("HH"); 
  lcd.setCursor(13, 0);  
  lcd.print(":");
  lcd.print("MM"); 
 //lcd.setCursor(5, 0);    
 // lcd.print(":");
 //lcd.print("SS");   
}

////////////////   LCD    PRINT ////////////////////

void LCDprint () {

     
 // LCD LATITUDE

  lcd.setCursor(1, 2);

  if ((latitude/1000000)<10){ 
  lcd.print("0");
  } 
  lcd.print(latitude/1000000, DEC);
  lcd.write(0);
  
  if (((latitude/10000)%100)<10) {
   lcd.print("0");
  } 
  
  lcd.print((latitude/10000)%100, DEC); 
  lcd.write(1);
  if ( ((latitude%10000)/100)< 10 ) {
  lcd.print("0");   
  }
  lcd.print((latitude%10000)/100, DEC);
 
 
  lcd.setCursor(9, 2);
   if (latdir == 'N')
       lcd.print(" N ");
    else if (latdir == 'S')
       lcd.print(" S ");

 // LCD LONGITUDE
 
  lcd.setCursor(0, 3);

  if ((longitude/1000000)<100) {
  lcd.print("0");
  } 
  if ((longitude/1000000)<10) {
  lcd.print("0");
  }
  lcd.print(longitude/1000000, DEC);
  lcd.write(0);
  
   if (((longitude/10000)%100)<10) { 
   lcd.print("0");
  }
  
  lcd.print((longitude/10000)%100, DEC); 
  lcd.write(1);
  
  if (((longitude%10000)/100)<10) {
    lcd.print("0"); 
  }
  lcd.print((longitude%10000)/100, DEC); 
 
 
  lcd.setCursor(9, 3);
   if (longdir == 'E')
       lcd.print(" E ");
    else if (longdir == 'W')
       lcd.print(" W ");
  
  // LCD TIME
  
    lcd.setCursor(11, 0);
      if (hour < 10) {
      lcd.print("0");
      } 
    lcd.print(hour, DEC); 
    
    lcd.setCursor(14, 0);  
      if (minute < 10) {
      lcd.print("0");
      }    
    lcd.print(minute, DEC); 
 
    //lcd.setCursor(6, 0);  
    //  if (second < 10) {
    //  lcd.print("0");
   //}    
   // lcd.print(second, DEC); 


//   LCD DATE

 
     lcd.setCursor(0, 0);
      if (date < 10) {
      lcd.print("0");
      } 
    lcd.print(date, DEC); 
    lcd.print("/"); 
    lcd.setCursor(3, 0);  
      if (month < 10) {
      lcd.print("0");
      }    
    lcd.print(month, DEC); 
    lcd.print("/"); 
    lcd.setCursor(6, 0);  
    lcd.print(year, DEC); 
    
    // Locator calculation ////////////////////////////////////////
 
     loclong = longitude;
     
     loclong = 1000000 * int (loclong/1000000) +  ((loclong - 1000000 *int (loclong/1000000))/ 0.6); 
     
     if (longdir == 'E') loclong = (loclong) + 180000000;
     if (longdir == 'W') loclong = 180000000 - (loclong);

     loclat = latitude;

     loclat = 1000000 * int (loclat/1000000) +  ((loclat - 1000000 * int (loclat/1000000))/ 0.6);   
        
     if (latdir == 'N')  loclat = loclat + 90000000;
     if (latdir == 'S')  loclat = 90000000 - loclat;
            
      lcd.setCursor(5, 1); 
     
     // First Character - longitude based (every 20В° = 1 gridsq)
         
      lcd.print(FirstCharString[int(loclong/20000000)]); 
      
    // Second Character - latitude based (every 10В° = 1 gridsq)
   
      lcd.print(FirstCharString[int(loclat/10000000)]); 
           
    // Third Character - longitude based (every 2В° = 1 gridsq)       
   
       scrap = loclong  -   (20000000 * int (loclong/20000000)); 
    
    //   lcd.print (scrap);  // D E B U G  field
       
      lcd.print(MidCharString[int(scrap*10/20/1000000)]); 
           
    // Fourth Character - latitude based (every 1В° = 1 gridsq)       
 
      scrap = loclat  -  (10000000 * int (loclat/10000000));   
      lcd.print(MidCharString[int(scrap/1000000)]);  
       
    // Fifth Character - longitude based (every 5' = 1 gridsq)       
 
      scrap = (loclong / 2000000)  -   (int (loclong/2000000));
       
      lcd.print(LastCharString[int(scrap * 24)]); 
   
    // Sixth Character - longitude based (every 2.5' = 1 gridsq)       
 
      scrap = (loclat / 1000000)  -   (int (loclat/1000000));
      lcd.print(LastCharString[int(scrap * 24)]); 
     } 


 

